'use strict';

exports.__esModule = true;

var _extends4 = require('babel-runtime/helpers/extends');

var _extends5 = _interopRequireDefault(_extends4);

exports.default = generateSchema;

var _fp = require('lodash/fp');

var _graphql = require('graphql');

var _typeForClass = require('./typeForClass');

var _typeForClass2 = _interopRequireDefault(_typeForClass);

var _dependencyHelper = require('./utils/dependencyHelper');

var _dependencyHelper2 = _interopRequireDefault(_dependencyHelper);

var _baseMapping = require('./baseMapping');

var _baseMapping2 = _interopRequireDefault(_baseMapping);

var _queryForType = require('./queryForType');

var _queryForType2 = _interopRequireDefault(_queryForType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function generateSchema(parseSchema) {
  var types = (0, _dependencyHelper2.default)(_baseMapping2.default, (0, _fp.flow)((0, _fp.reduce)(function (obj, data) {
    var _extends2;

    return (0, _extends5.default)({}, obj, (_extends2 = {}, _extends2[data.className] = data, _extends2));
  }, {}), (0, _fp.mapValues)(_typeForClass2.default))(parseSchema));

  console.log(types);

  var queryFields = parseSchema.reduce(function (acc, _ref) {
    var _extends3;

    var className = _ref.className;
    return (0, _extends5.default)({}, acc, (_extends3 = {}, _extends3[className] = (0, _queryForType2.default)(className, types[className]()), _extends3));
  }, {});

  var query = new _graphql.GraphQLObjectType({
    name: 'Query',
    fields: queryFields
  });

  return new _graphql.GraphQLSchema({ query: query });
}
module.exports = exports['default'];