'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _graphql = require('graphql');

var _graphqlTypeJson = require('graphql-type-json');

var _graphqlTypeJson2 = _interopRequireDefault(_graphqlTypeJson);

var _graphqlListFields = require('graphql-list-fields');

var _graphqlListFields2 = _interopRequireDefault(_graphqlListFields);

var _node = require('parse/node');

var _node2 = _interopRequireDefault(_node);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (parseClass, Type) {
  return {
    type: (0, _graphql.GraphQLList)(Type),
    args: {
      json: {
        type: _graphqlTypeJson2.default
      }
    },
    resolve: function resolve(_, _ref, context, info) {
      var json = _ref.json;

      var fields = (0, _graphqlListFields2.default)(info);
      var query = _node2.default.Query.fromJSON(parseClass, (0, _extends3.default)({}, json) || { where: {} });
      fields.forEach(function (field) {
        return query.include(field);
      });
      return query.find();
    }
  };
};

module.exports = exports['default'];