'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _graphql = require('graphql');

var _graphqlTypeJson = require('graphql-type-json');

var _graphqlTypeJson2 = _interopRequireDefault(_graphqlTypeJson);

var _lodash = require('lodash');

var _fp = require('lodash/fp');

var _mapType = require('./mapType');

var _mapType2 = _interopRequireDefault(_mapType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var specialResolvers = {
  objectId: (0, _fp.property)('id'),
  ACL: function ACL(item) {
    return item.getACL();
  },
  createdAt: (0, _fp.property)('createdAt'),
  updatedAt: (0, _fp.property)('updatedAt')
};

var standardResolver = function standardResolver(key) {
  return function (item) {
    return item.get(key);
  };
};

exports.default = function (_ref) {
  var className = _ref.className,
      fields = _ref.fields;
  return function (typeMap) {
    return (0, _fp.constant)(function () {
      var propertyFields = function propertyFields() {
        return (0, _lodash.mapValues)(fields, function (data, key) {
          return {
            type: (0, _mapType2.default)(data, typeMap),
            resolve: specialResolvers[key] || standardResolver(key)
          };
        });
      };

      return new _graphql.GraphQLObjectType({
        name: className,
        fields: function fields() {
          return (0, _extends3.default)({}, propertyFields(), {
            parseObjectJSON: {
              type: _graphqlTypeJson2.default,
              resolve: function resolve(item) {
                return item.toJSON();
              }
            }
          });
        }
      });
    }());
  };
};

module.exports = exports['default'];