'use strict';

exports.__esModule = true;

var _graphql = require('graphql');

exports.default = new _graphql.GraphQLObjectType({
  name: 'ACL',
  fields: {
    publicReadAccess: {
      type: _graphql.GraphQLBoolean,
      resolve: function resolve(acl) {
        return acl.getPublicReadAccess();
      }
    },
    publicWriteAccess: {
      type: _graphql.GraphQLBoolean,
      resolve: function resolve(acl) {
        return acl.getPublicWriteAccess();
      }
    },
    readAccess: {
      type: _graphql.GraphQLBoolean,
      resolve: function resolve(acl, _ref) {
        var userId = _ref.userId;

        return acl.getReadAccess(userId);
      }
    },
    writeAccess: {
      type: _graphql.GraphQLBoolean,
      resolve: function resolve(acl, _ref2) {
        var userId = _ref2.userId;

        return acl.getWriteAccess(userId);
      }
    },
    roleReadAccess: {
      type: _graphql.GraphQLBoolean,
      resolve: function resolve(acl, _ref3) {
        var role = _ref3.role;

        return acl.getRoleReadAccess(role);
      }
    },
    roleWriteAccess: {
      type: _graphql.GraphQLBoolean,
      resolve: function resolve(acl, _ref4) {
        var role = _ref4.role;

        return acl.getRoleWriteAccess(role);
      }
    }
  }
});
module.exports = exports['default'];