'use strict';

exports.__esModule = true;

var _graphql = require('graphql');

var _language = require('graphql/language');

var parseValue = function parseValue(dateString) {
  return new Date(dateString);
};

function parseLiteral(ast) {
  if (ast.kind !== _language.Kind.STRING) {
    throw new Error('Invalid value for Date scalar');
  }

  return parseValue(ast.value);
}

exports.default = new _graphql.GraphQLScalarType({
  name: 'Date',
  serialize: function serialize(date) {
    return date.toISOString();
  },
  parseValue: parseValue,
  parseLiteral: parseLiteral
});
module.exports = exports['default'];