"use strict";

exports.__esModule = true;

var _defineProperty = require("babel-runtime/core-js/object/define-property");

var _defineProperty2 = _interopRequireDefault(_defineProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Define a property whose value isn't computed until it is accessed,
 * at which point it is stored
 *
 * @param {Object} object - Object to set property on
 * @param {String} key - key of property
 * @param {Function} valueFunc - function that returns the value, only called once
 */
function defineLazyProperty(object, key, valueFunc) {
  (0, _defineProperty2.default)(object, key, {
    configurable: true,
    enumerable: true,
    get: function get() {
      delete this[key];
      (0, _defineProperty2.default)(this, key, {
        enumerable: true,
        value: valueFunc()
      });
      console.log(key, this[key]);
      return this[key];
    }
  });
}

exports.default = defineLazyProperty;
module.exports = exports["default"];