'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _lodash = require('lodash');

var _defineLazyProperty = require('./defineLazyProperty');

var _defineLazyProperty2 = _interopRequireDefault(_defineLazyProperty);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Simple dependency injector.
 * Circular dependencies will not work - but that should never be needed.
 * Uses getters - access dependencies on the returned object as properties
 *
 * @param {Object} defaultData - other dependencies to make available
 * @param {Object} initializerMap - map of functions that take dependencies obj as
 *   parameter and return something
 * @return {Object} Object with the keys of defaultData and initializerMap
 */
function dependencyHelper(defaultData, initializerMap) {
  return (0, _lodash.reduce)((0, _lodash.keys)(initializerMap), function (dependencies, key) {
    (0, _defineLazyProperty2.default)(dependencies, key, function () {
      return initializerMap[key](dependencies);
    });
    return dependencies;
  }, (0, _extends3.default)({}, defaultData));
}

exports.default = dependencyHelper;
module.exports = exports['default'];